// Generated by the gRPC C++ plugin.
// If you make any local change, they will be lost.
// source: speech/v1/cloud_speech.proto
#ifndef GRPC_speech_2fv1_2fcloud_5fspeech_2eproto__INCLUDED
#define GRPC_speech_2fv1_2fcloud_5fspeech_2eproto__INCLUDED

#include "speech/v1/cloud_speech.pb.h"

#include <grpc++/impl/codegen/async_stream.h>
#include <grpc++/impl/codegen/async_unary_call.h>
#include <grpc++/impl/codegen/method_handler_impl.h>
#include <grpc++/impl/codegen/proto_utils.h>
#include <grpc++/impl/codegen/rpc_method.h>
#include <grpc++/impl/codegen/service_type.h>
#include <grpc++/impl/codegen/status.h>
#include <grpc++/impl/codegen/stub_options.h>
#include <grpc++/impl/codegen/sync_stream.h>

namespace grpc {
class CompletionQueue;
class Channel;
class RpcService;
class ServerCompletionQueue;
class ServerContext;
}  // namespace grpc

namespace vais {
namespace cloud {
namespace speech {
namespace v1 {

class Speech final {
 public:
  static constexpr char const* service_full_name() {
    return "vais.cloud.speech.v1.Speech";
  }
  class StubInterface {
   public:
    virtual ~StubInterface() {}
    virtual ::grpc::Status Recognize(::grpc::ClientContext* context, const ::vais::cloud::speech::v1::RecognizeRequest& request, ::vais::cloud::speech::v1::RecognizeResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::vais::cloud::speech::v1::RecognizeResponse>> AsyncRecognize(::grpc::ClientContext* context, const ::vais::cloud::speech::v1::RecognizeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::vais::cloud::speech::v1::RecognizeResponse>>(AsyncRecognizeRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientReaderWriterInterface< ::vais::cloud::speech::v1::StreamingRecognizeRequest, ::vais::cloud::speech::v1::StreamingIntentRecognizeResponse>> StreamingIntentRecognize(::grpc::ClientContext* context) {
      return std::unique_ptr< ::grpc::ClientReaderWriterInterface< ::vais::cloud::speech::v1::StreamingRecognizeRequest, ::vais::cloud::speech::v1::StreamingIntentRecognizeResponse>>(StreamingIntentRecognizeRaw(context));
    }
    std::unique_ptr< ::grpc::ClientAsyncReaderWriterInterface< ::vais::cloud::speech::v1::StreamingRecognizeRequest, ::vais::cloud::speech::v1::StreamingIntentRecognizeResponse>> AsyncStreamingIntentRecognize(::grpc::ClientContext* context, ::grpc::CompletionQueue* cq, void* tag) {
      return std::unique_ptr< ::grpc::ClientAsyncReaderWriterInterface< ::vais::cloud::speech::v1::StreamingRecognizeRequest, ::vais::cloud::speech::v1::StreamingIntentRecognizeResponse>>(AsyncStreamingIntentRecognizeRaw(context, cq, tag));
    }
    std::unique_ptr< ::grpc::ClientReaderWriterInterface< ::vais::cloud::speech::v1::StreamingRecognizeRequest, ::vais::cloud::speech::v1::StreamingRecognizeResponse>> StreamingRecognize(::grpc::ClientContext* context) {
      return std::unique_ptr< ::grpc::ClientReaderWriterInterface< ::vais::cloud::speech::v1::StreamingRecognizeRequest, ::vais::cloud::speech::v1::StreamingRecognizeResponse>>(StreamingRecognizeRaw(context));
    }
    std::unique_ptr< ::grpc::ClientAsyncReaderWriterInterface< ::vais::cloud::speech::v1::StreamingRecognizeRequest, ::vais::cloud::speech::v1::StreamingRecognizeResponse>> AsyncStreamingRecognize(::grpc::ClientContext* context, ::grpc::CompletionQueue* cq, void* tag) {
      return std::unique_ptr< ::grpc::ClientAsyncReaderWriterInterface< ::vais::cloud::speech::v1::StreamingRecognizeRequest, ::vais::cloud::speech::v1::StreamingRecognizeResponse>>(AsyncStreamingRecognizeRaw(context, cq, tag));
    }
    virtual ::grpc::Status Text2SpeechHmmAiHoa(::grpc::ClientContext* context, const ::vais::cloud::speech::v1::TtsRequest& request, ::vais::cloud::speech::v1::TtsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::vais::cloud::speech::v1::TtsResponse>> AsyncText2SpeechHmmAiHoa(::grpc::ClientContext* context, const ::vais::cloud::speech::v1::TtsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::vais::cloud::speech::v1::TtsResponse>>(AsyncText2SpeechHmmAiHoaRaw(context, request, cq));
    }
    virtual ::grpc::Status Text2SpeechHmmMinhNguyet(::grpc::ClientContext* context, const ::vais::cloud::speech::v1::TtsRequest& request, ::vais::cloud::speech::v1::TtsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::vais::cloud::speech::v1::TtsResponse>> AsyncText2SpeechHmmMinhNguyet(::grpc::ClientContext* context, const ::vais::cloud::speech::v1::TtsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::vais::cloud::speech::v1::TtsResponse>>(AsyncText2SpeechHmmMinhNguyetRaw(context, request, cq));
    }
    virtual ::grpc::Status Text2SpeechConcatAiHoa(::grpc::ClientContext* context, const ::vais::cloud::speech::v1::TtsRequest& request, ::vais::cloud::speech::v1::TtsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::vais::cloud::speech::v1::TtsResponse>> AsyncText2SpeechConcatAiHoa(::grpc::ClientContext* context, const ::vais::cloud::speech::v1::TtsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::vais::cloud::speech::v1::TtsResponse>>(AsyncText2SpeechConcatAiHoaRaw(context, request, cq));
    }
    virtual ::grpc::Status Text2SpeechConcatMinhNguyet(::grpc::ClientContext* context, const ::vais::cloud::speech::v1::TtsRequest& request, ::vais::cloud::speech::v1::TtsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::vais::cloud::speech::v1::TtsResponse>> AsyncText2SpeechConcatMinhNguyet(::grpc::ClientContext* context, const ::vais::cloud::speech::v1::TtsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::vais::cloud::speech::v1::TtsResponse>>(AsyncText2SpeechConcatMinhNguyetRaw(context, request, cq));
    }
  private:
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::vais::cloud::speech::v1::RecognizeResponse>* AsyncRecognizeRaw(::grpc::ClientContext* context, const ::vais::cloud::speech::v1::RecognizeRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientReaderWriterInterface< ::vais::cloud::speech::v1::StreamingRecognizeRequest, ::vais::cloud::speech::v1::StreamingIntentRecognizeResponse>* StreamingIntentRecognizeRaw(::grpc::ClientContext* context) = 0;
    virtual ::grpc::ClientAsyncReaderWriterInterface< ::vais::cloud::speech::v1::StreamingRecognizeRequest, ::vais::cloud::speech::v1::StreamingIntentRecognizeResponse>* AsyncStreamingIntentRecognizeRaw(::grpc::ClientContext* context, ::grpc::CompletionQueue* cq, void* tag) = 0;
    virtual ::grpc::ClientReaderWriterInterface< ::vais::cloud::speech::v1::StreamingRecognizeRequest, ::vais::cloud::speech::v1::StreamingRecognizeResponse>* StreamingRecognizeRaw(::grpc::ClientContext* context) = 0;
    virtual ::grpc::ClientAsyncReaderWriterInterface< ::vais::cloud::speech::v1::StreamingRecognizeRequest, ::vais::cloud::speech::v1::StreamingRecognizeResponse>* AsyncStreamingRecognizeRaw(::grpc::ClientContext* context, ::grpc::CompletionQueue* cq, void* tag) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::vais::cloud::speech::v1::TtsResponse>* AsyncText2SpeechHmmAiHoaRaw(::grpc::ClientContext* context, const ::vais::cloud::speech::v1::TtsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::vais::cloud::speech::v1::TtsResponse>* AsyncText2SpeechHmmMinhNguyetRaw(::grpc::ClientContext* context, const ::vais::cloud::speech::v1::TtsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::vais::cloud::speech::v1::TtsResponse>* AsyncText2SpeechConcatAiHoaRaw(::grpc::ClientContext* context, const ::vais::cloud::speech::v1::TtsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::vais::cloud::speech::v1::TtsResponse>* AsyncText2SpeechConcatMinhNguyetRaw(::grpc::ClientContext* context, const ::vais::cloud::speech::v1::TtsRequest& request, ::grpc::CompletionQueue* cq) = 0;
  };
  class Stub final : public StubInterface {
   public:
    Stub(const std::shared_ptr< ::grpc::ChannelInterface>& channel);
    ::grpc::Status Recognize(::grpc::ClientContext* context, const ::vais::cloud::speech::v1::RecognizeRequest& request, ::vais::cloud::speech::v1::RecognizeResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::vais::cloud::speech::v1::RecognizeResponse>> AsyncRecognize(::grpc::ClientContext* context, const ::vais::cloud::speech::v1::RecognizeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::vais::cloud::speech::v1::RecognizeResponse>>(AsyncRecognizeRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientReaderWriter< ::vais::cloud::speech::v1::StreamingRecognizeRequest, ::vais::cloud::speech::v1::StreamingIntentRecognizeResponse>> StreamingIntentRecognize(::grpc::ClientContext* context) {
      return std::unique_ptr< ::grpc::ClientReaderWriter< ::vais::cloud::speech::v1::StreamingRecognizeRequest, ::vais::cloud::speech::v1::StreamingIntentRecognizeResponse>>(StreamingIntentRecognizeRaw(context));
    }
    std::unique_ptr<  ::grpc::ClientAsyncReaderWriter< ::vais::cloud::speech::v1::StreamingRecognizeRequest, ::vais::cloud::speech::v1::StreamingIntentRecognizeResponse>> AsyncStreamingIntentRecognize(::grpc::ClientContext* context, ::grpc::CompletionQueue* cq, void* tag) {
      return std::unique_ptr< ::grpc::ClientAsyncReaderWriter< ::vais::cloud::speech::v1::StreamingRecognizeRequest, ::vais::cloud::speech::v1::StreamingIntentRecognizeResponse>>(AsyncStreamingIntentRecognizeRaw(context, cq, tag));
    }
    std::unique_ptr< ::grpc::ClientReaderWriter< ::vais::cloud::speech::v1::StreamingRecognizeRequest, ::vais::cloud::speech::v1::StreamingRecognizeResponse>> StreamingRecognize(::grpc::ClientContext* context) {
      return std::unique_ptr< ::grpc::ClientReaderWriter< ::vais::cloud::speech::v1::StreamingRecognizeRequest, ::vais::cloud::speech::v1::StreamingRecognizeResponse>>(StreamingRecognizeRaw(context));
    }
    std::unique_ptr<  ::grpc::ClientAsyncReaderWriter< ::vais::cloud::speech::v1::StreamingRecognizeRequest, ::vais::cloud::speech::v1::StreamingRecognizeResponse>> AsyncStreamingRecognize(::grpc::ClientContext* context, ::grpc::CompletionQueue* cq, void* tag) {
      return std::unique_ptr< ::grpc::ClientAsyncReaderWriter< ::vais::cloud::speech::v1::StreamingRecognizeRequest, ::vais::cloud::speech::v1::StreamingRecognizeResponse>>(AsyncStreamingRecognizeRaw(context, cq, tag));
    }
    ::grpc::Status Text2SpeechHmmAiHoa(::grpc::ClientContext* context, const ::vais::cloud::speech::v1::TtsRequest& request, ::vais::cloud::speech::v1::TtsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::vais::cloud::speech::v1::TtsResponse>> AsyncText2SpeechHmmAiHoa(::grpc::ClientContext* context, const ::vais::cloud::speech::v1::TtsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::vais::cloud::speech::v1::TtsResponse>>(AsyncText2SpeechHmmAiHoaRaw(context, request, cq));
    }
    ::grpc::Status Text2SpeechHmmMinhNguyet(::grpc::ClientContext* context, const ::vais::cloud::speech::v1::TtsRequest& request, ::vais::cloud::speech::v1::TtsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::vais::cloud::speech::v1::TtsResponse>> AsyncText2SpeechHmmMinhNguyet(::grpc::ClientContext* context, const ::vais::cloud::speech::v1::TtsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::vais::cloud::speech::v1::TtsResponse>>(AsyncText2SpeechHmmMinhNguyetRaw(context, request, cq));
    }
    ::grpc::Status Text2SpeechConcatAiHoa(::grpc::ClientContext* context, const ::vais::cloud::speech::v1::TtsRequest& request, ::vais::cloud::speech::v1::TtsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::vais::cloud::speech::v1::TtsResponse>> AsyncText2SpeechConcatAiHoa(::grpc::ClientContext* context, const ::vais::cloud::speech::v1::TtsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::vais::cloud::speech::v1::TtsResponse>>(AsyncText2SpeechConcatAiHoaRaw(context, request, cq));
    }
    ::grpc::Status Text2SpeechConcatMinhNguyet(::grpc::ClientContext* context, const ::vais::cloud::speech::v1::TtsRequest& request, ::vais::cloud::speech::v1::TtsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::vais::cloud::speech::v1::TtsResponse>> AsyncText2SpeechConcatMinhNguyet(::grpc::ClientContext* context, const ::vais::cloud::speech::v1::TtsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::vais::cloud::speech::v1::TtsResponse>>(AsyncText2SpeechConcatMinhNguyetRaw(context, request, cq));
    }

   private:
    std::shared_ptr< ::grpc::ChannelInterface> channel_;
    ::grpc::ClientAsyncResponseReader< ::vais::cloud::speech::v1::RecognizeResponse>* AsyncRecognizeRaw(::grpc::ClientContext* context, const ::vais::cloud::speech::v1::RecognizeRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientReaderWriter< ::vais::cloud::speech::v1::StreamingRecognizeRequest, ::vais::cloud::speech::v1::StreamingIntentRecognizeResponse>* StreamingIntentRecognizeRaw(::grpc::ClientContext* context) override;
    ::grpc::ClientAsyncReaderWriter< ::vais::cloud::speech::v1::StreamingRecognizeRequest, ::vais::cloud::speech::v1::StreamingIntentRecognizeResponse>* AsyncStreamingIntentRecognizeRaw(::grpc::ClientContext* context, ::grpc::CompletionQueue* cq, void* tag) override;
    ::grpc::ClientReaderWriter< ::vais::cloud::speech::v1::StreamingRecognizeRequest, ::vais::cloud::speech::v1::StreamingRecognizeResponse>* StreamingRecognizeRaw(::grpc::ClientContext* context) override;
    ::grpc::ClientAsyncReaderWriter< ::vais::cloud::speech::v1::StreamingRecognizeRequest, ::vais::cloud::speech::v1::StreamingRecognizeResponse>* AsyncStreamingRecognizeRaw(::grpc::ClientContext* context, ::grpc::CompletionQueue* cq, void* tag) override;
    ::grpc::ClientAsyncResponseReader< ::vais::cloud::speech::v1::TtsResponse>* AsyncText2SpeechHmmAiHoaRaw(::grpc::ClientContext* context, const ::vais::cloud::speech::v1::TtsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::vais::cloud::speech::v1::TtsResponse>* AsyncText2SpeechHmmMinhNguyetRaw(::grpc::ClientContext* context, const ::vais::cloud::speech::v1::TtsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::vais::cloud::speech::v1::TtsResponse>* AsyncText2SpeechConcatAiHoaRaw(::grpc::ClientContext* context, const ::vais::cloud::speech::v1::TtsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::vais::cloud::speech::v1::TtsResponse>* AsyncText2SpeechConcatMinhNguyetRaw(::grpc::ClientContext* context, const ::vais::cloud::speech::v1::TtsRequest& request, ::grpc::CompletionQueue* cq) override;
    const ::grpc::RpcMethod rpcmethod_Recognize_;
    const ::grpc::RpcMethod rpcmethod_StreamingIntentRecognize_;
    const ::grpc::RpcMethod rpcmethod_StreamingRecognize_;
    const ::grpc::RpcMethod rpcmethod_Text2SpeechHmmAiHoa_;
    const ::grpc::RpcMethod rpcmethod_Text2SpeechHmmMinhNguyet_;
    const ::grpc::RpcMethod rpcmethod_Text2SpeechConcatAiHoa_;
    const ::grpc::RpcMethod rpcmethod_Text2SpeechConcatMinhNguyet_;
  };
  static std::unique_ptr<Stub> NewStub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());

  class Service : public ::grpc::Service {
   public:
    Service();
    virtual ~Service();
    virtual ::grpc::Status Recognize(::grpc::ServerContext* context, const ::vais::cloud::speech::v1::RecognizeRequest* request, ::vais::cloud::speech::v1::RecognizeResponse* response);
    virtual ::grpc::Status StreamingIntentRecognize(::grpc::ServerContext* context, ::grpc::ServerReaderWriter< ::vais::cloud::speech::v1::StreamingIntentRecognizeResponse, ::vais::cloud::speech::v1::StreamingRecognizeRequest>* stream);
    virtual ::grpc::Status StreamingRecognize(::grpc::ServerContext* context, ::grpc::ServerReaderWriter< ::vais::cloud::speech::v1::StreamingRecognizeResponse, ::vais::cloud::speech::v1::StreamingRecognizeRequest>* stream);
    virtual ::grpc::Status Text2SpeechHmmAiHoa(::grpc::ServerContext* context, const ::vais::cloud::speech::v1::TtsRequest* request, ::vais::cloud::speech::v1::TtsResponse* response);
    virtual ::grpc::Status Text2SpeechHmmMinhNguyet(::grpc::ServerContext* context, const ::vais::cloud::speech::v1::TtsRequest* request, ::vais::cloud::speech::v1::TtsResponse* response);
    virtual ::grpc::Status Text2SpeechConcatAiHoa(::grpc::ServerContext* context, const ::vais::cloud::speech::v1::TtsRequest* request, ::vais::cloud::speech::v1::TtsResponse* response);
    virtual ::grpc::Status Text2SpeechConcatMinhNguyet(::grpc::ServerContext* context, const ::vais::cloud::speech::v1::TtsRequest* request, ::vais::cloud::speech::v1::TtsResponse* response);
  };
  template <class BaseClass>
  class WithAsyncMethod_Recognize : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service *service) {}
   public:
    WithAsyncMethod_Recognize() {
      ::grpc::Service::MarkMethodAsync(0);
    }
    ~WithAsyncMethod_Recognize() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status Recognize(::grpc::ServerContext* context, const ::vais::cloud::speech::v1::RecognizeRequest* request, ::vais::cloud::speech::v1::RecognizeResponse* response) final override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestRecognize(::grpc::ServerContext* context, ::vais::cloud::speech::v1::RecognizeRequest* request, ::grpc::ServerAsyncResponseWriter< ::vais::cloud::speech::v1::RecognizeResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_StreamingIntentRecognize : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service *service) {}
   public:
    WithAsyncMethod_StreamingIntentRecognize() {
      ::grpc::Service::MarkMethodAsync(1);
    }
    ~WithAsyncMethod_StreamingIntentRecognize() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status StreamingIntentRecognize(::grpc::ServerContext* context, ::grpc::ServerReaderWriter< ::vais::cloud::speech::v1::StreamingIntentRecognizeResponse, ::vais::cloud::speech::v1::StreamingRecognizeRequest>* stream) final override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestStreamingIntentRecognize(::grpc::ServerContext* context, ::grpc::ServerAsyncReaderWriter< ::vais::cloud::speech::v1::StreamingIntentRecognizeResponse, ::vais::cloud::speech::v1::StreamingRecognizeRequest>* stream, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncBidiStreaming(1, context, stream, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_StreamingRecognize : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service *service) {}
   public:
    WithAsyncMethod_StreamingRecognize() {
      ::grpc::Service::MarkMethodAsync(2);
    }
    ~WithAsyncMethod_StreamingRecognize() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status StreamingRecognize(::grpc::ServerContext* context, ::grpc::ServerReaderWriter< ::vais::cloud::speech::v1::StreamingRecognizeResponse, ::vais::cloud::speech::v1::StreamingRecognizeRequest>* stream) final override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestStreamingRecognize(::grpc::ServerContext* context, ::grpc::ServerAsyncReaderWriter< ::vais::cloud::speech::v1::StreamingRecognizeResponse, ::vais::cloud::speech::v1::StreamingRecognizeRequest>* stream, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncBidiStreaming(2, context, stream, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_Text2SpeechHmmAiHoa : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service *service) {}
   public:
    WithAsyncMethod_Text2SpeechHmmAiHoa() {
      ::grpc::Service::MarkMethodAsync(3);
    }
    ~WithAsyncMethod_Text2SpeechHmmAiHoa() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status Text2SpeechHmmAiHoa(::grpc::ServerContext* context, const ::vais::cloud::speech::v1::TtsRequest* request, ::vais::cloud::speech::v1::TtsResponse* response) final override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestText2SpeechHmmAiHoa(::grpc::ServerContext* context, ::vais::cloud::speech::v1::TtsRequest* request, ::grpc::ServerAsyncResponseWriter< ::vais::cloud::speech::v1::TtsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_Text2SpeechHmmMinhNguyet : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service *service) {}
   public:
    WithAsyncMethod_Text2SpeechHmmMinhNguyet() {
      ::grpc::Service::MarkMethodAsync(4);
    }
    ~WithAsyncMethod_Text2SpeechHmmMinhNguyet() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status Text2SpeechHmmMinhNguyet(::grpc::ServerContext* context, const ::vais::cloud::speech::v1::TtsRequest* request, ::vais::cloud::speech::v1::TtsResponse* response) final override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestText2SpeechHmmMinhNguyet(::grpc::ServerContext* context, ::vais::cloud::speech::v1::TtsRequest* request, ::grpc::ServerAsyncResponseWriter< ::vais::cloud::speech::v1::TtsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_Text2SpeechConcatAiHoa : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service *service) {}
   public:
    WithAsyncMethod_Text2SpeechConcatAiHoa() {
      ::grpc::Service::MarkMethodAsync(5);
    }
    ~WithAsyncMethod_Text2SpeechConcatAiHoa() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status Text2SpeechConcatAiHoa(::grpc::ServerContext* context, const ::vais::cloud::speech::v1::TtsRequest* request, ::vais::cloud::speech::v1::TtsResponse* response) final override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestText2SpeechConcatAiHoa(::grpc::ServerContext* context, ::vais::cloud::speech::v1::TtsRequest* request, ::grpc::ServerAsyncResponseWriter< ::vais::cloud::speech::v1::TtsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_Text2SpeechConcatMinhNguyet : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service *service) {}
   public:
    WithAsyncMethod_Text2SpeechConcatMinhNguyet() {
      ::grpc::Service::MarkMethodAsync(6);
    }
    ~WithAsyncMethod_Text2SpeechConcatMinhNguyet() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status Text2SpeechConcatMinhNguyet(::grpc::ServerContext* context, const ::vais::cloud::speech::v1::TtsRequest* request, ::vais::cloud::speech::v1::TtsResponse* response) final override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestText2SpeechConcatMinhNguyet(::grpc::ServerContext* context, ::vais::cloud::speech::v1::TtsRequest* request, ::grpc::ServerAsyncResponseWriter< ::vais::cloud::speech::v1::TtsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(6, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  typedef WithAsyncMethod_Recognize<WithAsyncMethod_StreamingIntentRecognize<WithAsyncMethod_StreamingRecognize<WithAsyncMethod_Text2SpeechHmmAiHoa<WithAsyncMethod_Text2SpeechHmmMinhNguyet<WithAsyncMethod_Text2SpeechConcatAiHoa<WithAsyncMethod_Text2SpeechConcatMinhNguyet<Service > > > > > > > AsyncService;
  template <class BaseClass>
  class WithGenericMethod_Recognize : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service *service) {}
   public:
    WithGenericMethod_Recognize() {
      ::grpc::Service::MarkMethodGeneric(0);
    }
    ~WithGenericMethod_Recognize() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status Recognize(::grpc::ServerContext* context, const ::vais::cloud::speech::v1::RecognizeRequest* request, ::vais::cloud::speech::v1::RecognizeResponse* response) final override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_StreamingIntentRecognize : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service *service) {}
   public:
    WithGenericMethod_StreamingIntentRecognize() {
      ::grpc::Service::MarkMethodGeneric(1);
    }
    ~WithGenericMethod_StreamingIntentRecognize() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status StreamingIntentRecognize(::grpc::ServerContext* context, ::grpc::ServerReaderWriter< ::vais::cloud::speech::v1::StreamingIntentRecognizeResponse, ::vais::cloud::speech::v1::StreamingRecognizeRequest>* stream) final override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_StreamingRecognize : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service *service) {}
   public:
    WithGenericMethod_StreamingRecognize() {
      ::grpc::Service::MarkMethodGeneric(2);
    }
    ~WithGenericMethod_StreamingRecognize() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status StreamingRecognize(::grpc::ServerContext* context, ::grpc::ServerReaderWriter< ::vais::cloud::speech::v1::StreamingRecognizeResponse, ::vais::cloud::speech::v1::StreamingRecognizeRequest>* stream) final override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_Text2SpeechHmmAiHoa : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service *service) {}
   public:
    WithGenericMethod_Text2SpeechHmmAiHoa() {
      ::grpc::Service::MarkMethodGeneric(3);
    }
    ~WithGenericMethod_Text2SpeechHmmAiHoa() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status Text2SpeechHmmAiHoa(::grpc::ServerContext* context, const ::vais::cloud::speech::v1::TtsRequest* request, ::vais::cloud::speech::v1::TtsResponse* response) final override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_Text2SpeechHmmMinhNguyet : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service *service) {}
   public:
    WithGenericMethod_Text2SpeechHmmMinhNguyet() {
      ::grpc::Service::MarkMethodGeneric(4);
    }
    ~WithGenericMethod_Text2SpeechHmmMinhNguyet() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status Text2SpeechHmmMinhNguyet(::grpc::ServerContext* context, const ::vais::cloud::speech::v1::TtsRequest* request, ::vais::cloud::speech::v1::TtsResponse* response) final override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_Text2SpeechConcatAiHoa : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service *service) {}
   public:
    WithGenericMethod_Text2SpeechConcatAiHoa() {
      ::grpc::Service::MarkMethodGeneric(5);
    }
    ~WithGenericMethod_Text2SpeechConcatAiHoa() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status Text2SpeechConcatAiHoa(::grpc::ServerContext* context, const ::vais::cloud::speech::v1::TtsRequest* request, ::vais::cloud::speech::v1::TtsResponse* response) final override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_Text2SpeechConcatMinhNguyet : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service *service) {}
   public:
    WithGenericMethod_Text2SpeechConcatMinhNguyet() {
      ::grpc::Service::MarkMethodGeneric(6);
    }
    ~WithGenericMethod_Text2SpeechConcatMinhNguyet() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status Text2SpeechConcatMinhNguyet(::grpc::ServerContext* context, const ::vais::cloud::speech::v1::TtsRequest* request, ::vais::cloud::speech::v1::TtsResponse* response) final override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_Recognize : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service *service) {}
   public:
    WithStreamedUnaryMethod_Recognize() {
      ::grpc::Service::MarkMethodStreamed(0,
        new ::grpc::StreamedUnaryHandler< ::vais::cloud::speech::v1::RecognizeRequest, ::vais::cloud::speech::v1::RecognizeResponse>(std::bind(&WithStreamedUnaryMethod_Recognize<BaseClass>::StreamedRecognize, this, std::placeholders::_1, std::placeholders::_2)));
    }
    ~WithStreamedUnaryMethod_Recognize() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status Recognize(::grpc::ServerContext* context, const ::vais::cloud::speech::v1::RecognizeRequest* request, ::vais::cloud::speech::v1::RecognizeResponse* response) final override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedRecognize(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::vais::cloud::speech::v1::RecognizeRequest,::vais::cloud::speech::v1::RecognizeResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_Text2SpeechHmmAiHoa : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service *service) {}
   public:
    WithStreamedUnaryMethod_Text2SpeechHmmAiHoa() {
      ::grpc::Service::MarkMethodStreamed(3,
        new ::grpc::StreamedUnaryHandler< ::vais::cloud::speech::v1::TtsRequest, ::vais::cloud::speech::v1::TtsResponse>(std::bind(&WithStreamedUnaryMethod_Text2SpeechHmmAiHoa<BaseClass>::StreamedText2SpeechHmmAiHoa, this, std::placeholders::_1, std::placeholders::_2)));
    }
    ~WithStreamedUnaryMethod_Text2SpeechHmmAiHoa() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status Text2SpeechHmmAiHoa(::grpc::ServerContext* context, const ::vais::cloud::speech::v1::TtsRequest* request, ::vais::cloud::speech::v1::TtsResponse* response) final override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedText2SpeechHmmAiHoa(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::vais::cloud::speech::v1::TtsRequest,::vais::cloud::speech::v1::TtsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_Text2SpeechHmmMinhNguyet : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service *service) {}
   public:
    WithStreamedUnaryMethod_Text2SpeechHmmMinhNguyet() {
      ::grpc::Service::MarkMethodStreamed(4,
        new ::grpc::StreamedUnaryHandler< ::vais::cloud::speech::v1::TtsRequest, ::vais::cloud::speech::v1::TtsResponse>(std::bind(&WithStreamedUnaryMethod_Text2SpeechHmmMinhNguyet<BaseClass>::StreamedText2SpeechHmmMinhNguyet, this, std::placeholders::_1, std::placeholders::_2)));
    }
    ~WithStreamedUnaryMethod_Text2SpeechHmmMinhNguyet() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status Text2SpeechHmmMinhNguyet(::grpc::ServerContext* context, const ::vais::cloud::speech::v1::TtsRequest* request, ::vais::cloud::speech::v1::TtsResponse* response) final override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedText2SpeechHmmMinhNguyet(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::vais::cloud::speech::v1::TtsRequest,::vais::cloud::speech::v1::TtsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_Text2SpeechConcatAiHoa : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service *service) {}
   public:
    WithStreamedUnaryMethod_Text2SpeechConcatAiHoa() {
      ::grpc::Service::MarkMethodStreamed(5,
        new ::grpc::StreamedUnaryHandler< ::vais::cloud::speech::v1::TtsRequest, ::vais::cloud::speech::v1::TtsResponse>(std::bind(&WithStreamedUnaryMethod_Text2SpeechConcatAiHoa<BaseClass>::StreamedText2SpeechConcatAiHoa, this, std::placeholders::_1, std::placeholders::_2)));
    }
    ~WithStreamedUnaryMethod_Text2SpeechConcatAiHoa() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status Text2SpeechConcatAiHoa(::grpc::ServerContext* context, const ::vais::cloud::speech::v1::TtsRequest* request, ::vais::cloud::speech::v1::TtsResponse* response) final override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedText2SpeechConcatAiHoa(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::vais::cloud::speech::v1::TtsRequest,::vais::cloud::speech::v1::TtsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_Text2SpeechConcatMinhNguyet : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service *service) {}
   public:
    WithStreamedUnaryMethod_Text2SpeechConcatMinhNguyet() {
      ::grpc::Service::MarkMethodStreamed(6,
        new ::grpc::StreamedUnaryHandler< ::vais::cloud::speech::v1::TtsRequest, ::vais::cloud::speech::v1::TtsResponse>(std::bind(&WithStreamedUnaryMethod_Text2SpeechConcatMinhNguyet<BaseClass>::StreamedText2SpeechConcatMinhNguyet, this, std::placeholders::_1, std::placeholders::_2)));
    }
    ~WithStreamedUnaryMethod_Text2SpeechConcatMinhNguyet() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status Text2SpeechConcatMinhNguyet(::grpc::ServerContext* context, const ::vais::cloud::speech::v1::TtsRequest* request, ::vais::cloud::speech::v1::TtsResponse* response) final override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedText2SpeechConcatMinhNguyet(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::vais::cloud::speech::v1::TtsRequest,::vais::cloud::speech::v1::TtsResponse>* server_unary_streamer) = 0;
  };
  typedef WithStreamedUnaryMethod_Recognize<WithStreamedUnaryMethod_Text2SpeechHmmAiHoa<WithStreamedUnaryMethod_Text2SpeechHmmMinhNguyet<WithStreamedUnaryMethod_Text2SpeechConcatAiHoa<WithStreamedUnaryMethod_Text2SpeechConcatMinhNguyet<Service > > > > > StreamedUnaryService;
  typedef Service SplitStreamedService;
  typedef WithStreamedUnaryMethod_Recognize<WithStreamedUnaryMethod_Text2SpeechHmmAiHoa<WithStreamedUnaryMethod_Text2SpeechHmmMinhNguyet<WithStreamedUnaryMethod_Text2SpeechConcatAiHoa<WithStreamedUnaryMethod_Text2SpeechConcatMinhNguyet<Service > > > > > StreamedService;
};

}  // namespace v1
}  // namespace speech
}  // namespace cloud
}  // namespace vais


#endif  // GRPC_speech_2fv1_2fcloud_5fspeech_2eproto__INCLUDED
